#!/usr/bin/perl


use Pg;
require('../common/config');


# read STDIN
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});

# if we pass it via URI
if ($number = $ENV{'QUERY_STRING'}) {
  $_ = $number;
}


# strip number= at beginning
s/^number=//;

# translate to upper case
tr/a-z/A-Z/;


@pn = split(/\+/);


print "Content-type: text/html

<title>Alternate Search Results</title>

<body bgcolor=ffffff>

<h2>Alternate Search Result</h2>

<hr>
<pre>
";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


if (@pn) {

  # check each item in database
  foreach $item (@pn) {

    $item =~ s/%(..)/pack("c",hex($1))/ge;
    
    for $k (0..1) {
      if ($k) {
	$whichone = "oem_number";
      } else {
	$whichone = "alt_number";
      }
	  
      $query = "select oem_number,alt_number,oid from alternate where $whichone = \'$item\';";
      $parts = PQexec($conn, $query);
      $n = PQntuples($parts);

      if ($n) {
	for $i (0..$n-1) {
  
	  $pn = PQgetvalue($parts, $i, 0);
	  $alt = PQgetvalue($parts, $i, 1);
	  $oid = PQgetvalue($parts, $i, 2);

	  print "<b>OEM Number:</b> <a href=/parts/search.pl?$pn>$pn</a>";
	  print " " x (16 - length($pn));

	  print "  <b>Alternate:</b> <a href=/parts/search.pl?$alt>$alt</a>";
	  print " " x (16 - length($alt));

	  print "[ <a href=edit.pl?$oid>Edit</a> ] [ <a href=delete.pl?$oid>Delete</a> ]

";
	}
      } else {
	if ($k) {   # oem_number
	  print "<font color=red size=+3><a href=add.pl?oem_number\=$item>$item</a> not on file</font> <-- click on number to add as <b>OEM Number</b>

";
	} else {    # alt_number
	  print "<font color=red size=+3><a href=add.pl?alt_number\=$item>$item</a> not on file</font> <-- click on number to add as <b>ALTERNATE Number</b>

";
	}
      }
      
      PQclear($parts);
      
    }
  }
  print "</pre>";
}



PQfinish($conn);


print "

<p>If the number is not on file as OEM or ALTERNATE 
you have a choice to add the
number. Click on the number to add as either OEM or Alternate to
the <b>ALTERNATE TABLE</b>

<p>Click on the OEM number to show details for the part.

</body>
</html>
";


