#!/usr/bin/perl


use Pg;
require('../common/config');


$sortorder = $ENV{'QUERY_STRING'};

print "Content-type: text/html\n\n";
print "<body bgcolor=ffffff>\n";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


print "<h2>All A/P Invoices</h2>\n";


$query = "select a.invnumber,a.invdate,s.name,a.amount+a.tax1+a.tax2,";
$query .= "a.currency,a.amountpaid,a.duedate,s.oid,a.oid ";
$query .= "from ap a, vendor s where a.vendor = s.id order by $sortorder;";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {

#09-09-1998 12345678901234567890 1234567890 12345.99 CDN 12345.99 09-09-1998

  print "<pre>

   <a href=listall.pl?a.invdate>Date</a>           <a href=listall.pl?s.name,a.invdate>Vendor</a>           Invoice No    Amount     Paid CUR    <a href=listall.pl?a.duedate>Due</a>
-------------------------------------------------------------------------------
";

  for $i (0 .. $n-1) {
    
    $invnumber = PQgetvalue($ct, $i, 0);
    $invdate = PQgetvalue($ct, $i, 1);
    $vendor = PQgetvalue($ct, $i, 2);
    $amount = sprintf("%.2f", PQgetvalue($ct, $i, 3));
    $currency = PQgetvalue($ct, $i, 4);
    $amountpaid = sprintf("%.2f", PQgetvalue($ct, $i, 5));
    $duedate = PQgetvalue($ct, $i, 6);
    
    $soid = PQgetvalue($ct, $i, 7);
    $oid = PQgetvalue($ct, $i, 8);

    # keep a running total
    $total{$currency} += $amount;
    $totalpaid{$currency} += $amountpaid;
  
    printf("%s", $invdate);
    printf(" <a href=/vendor/edit.pl?%s>%s</a>", $soid, substr($vendor,0,23));
    $padding = " " x (23-length($vendor));
    printf("%s", $padding);
    
    printf(" <a href=edit.pl?%s>%s</a>", $oid, substr($invnumber,0,11));
    
    $padding = " " x (11-length($invnumber));
    printf("%s", $padding);
    
    printf(" %8.2f %8.2f %3s %s\n", $amount, $amountpaid, $currency, $duedate);
    
  }
  

  print "
  
  Total Payable: ";
  while (($key, $val) = each %total) {
    printf("  %8.2f %s" , $val - $totalpaid{$key}, $key);
  }

  print "
   Ledger Total: ";
  while (($key, $val) = each %total) {
    printf("  %8.2f %s", $val, $key);
  }
  print "
</pre>";
  
} else {
  print "<h2><font color=red>No Accounts Payables History!</font></h2>";
}

PQclear($ct);

PQfinish($conn);

print "

<p>
Click on the table header to sort table.
<br>Click on Vendor to edit VENDOR
<br>Click on Invoice Number to edit TRANSACTION

</body>
</html>
";

