#!/usr/bin/perl


use Pg;
require('../common/config');

# pass string to sort by
$sortorder = $ENV{'QUERY_STRING'};


print "Content-type: text/html

<title>Outstanding A/R</title>

<body bgcolor=ffffff>
";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


print "<h2>Outstanding Receivables</h2>\n";


$query = "select a.invnumber,a.invdate,c.name,a.amount+a.tax1+a.tax2,";
$query .= "a.currency,a.amountpaid,a.duedate,c.oid,a.oid ";
$query .= "from ar a, customer c ";
$query .= "where ((a.amount+a.tax1+a.tax2-a.amountpaid)*100)::int <> 0 ";
$query .= "and a.customer = c.id order by $sortorder;";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {

  print "<pre>

   <a href=listopen.pl?a.invdate>Date</a>           <a href=listopen.pl?c.name,a.invdate>Customer</a>         Invoice No    Amount     Paid CUR    <a href=listopen.pl?a.duedate>Due</a>
-------------------------------------------------------------------------------
";
  

  for $i (0 .. $n-1) {
    
    $invnumber = PQgetvalue($ct, $i, 0);
    $invdate = PQgetvalue($ct, $i, 1);
    $customer = PQgetvalue($ct, $i, 2);
    $amount = sprintf("%.2f", PQgetvalue($ct, $i, 3));
    $currency = PQgetvalue($ct, $i, 4);
    $amountpaid = sprintf("%.2f", PQgetvalue($ct, $i, 5));
    $duedate = PQgetvalue($ct, $i, 6);
    
    $coid = PQgetvalue($ct, $i, 7);
    $oid = PQgetvalue($ct, $i, 8);

    # keep a running total
    $total{$currency} += $amount;
    $totalpaid{$currency} += $amountpaid;
    
    printf("%s", $invdate);
    printf(" <a href=/customer/edit.pl?%s>%s</a>", $coid, substr($customer,0,23));
    $padding = " " x (23-length($customer));
    printf("%s", $padding);

    printf(" <a href=edit.pl?%s>%s</a>", $oid, substr($invnumber,0,11));

    $padding = " " x (11-length($invnumber));
    printf("%s", $padding);

    printf(" %8.2f %8.2f %3s %s\n", $amount, $amountpaid, $currency, $duedate);


  }
  
  print "

  Outstanding: ";
  while (($key, $val) = each %total) {
    printf("  %8.2f %s", $val - $totalpaid{$key}, $key);
  }

  print "
</pre>";
  
} else {
  print "<h2><font color=red>No Accounts Receivables History!</font></h2>";
}

PQclear($ct);

PQfinish($conn);

print "

<p>
Click on the table header to sort table.
<br>Click on Customer to edit CUSTOMER
<br>Click on Invoice Number to edit TRANSACTION

</body>
</html>
";

