#!/usr/bin/perl


use Pg;
require('../common/config');
require('dbstruct');

# pass string to sort by
$sortorder = $ENV{'QUERY_STRING'};


print "Content-type: text/html

<title>$tablename Transactions</title>

<body bgcolor=ffffff>
";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


print "<h2>$tablename Transactions</h2>\n";


$query = "select *,oid from $table order by $sortorder;";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {
  print "<pre>
   <a href=listall.pl?transdate>Date</a>    <a href=listall.pl?description,transdate>Description</a>               Deposits  Cheques  Balance <a href=listall.pl?chqnumber>Chq#</a> Clear
----------------------------------------------------------------------------
";
#09-09-1998 1234567890123456789012345 12345.78 12345.78 12345.78 1234 YES
#  <a href=listall.pl?transdate>Date</a>
#  <a href=listall.pl?description,transdate>Description</a>
#  <a href=listall.pl?chqnumber>Chq #</a>
  
  for $i (0 .. $n-1) {
    
    $transdate = PQgetvalue($ct, $i, 0);
    $description = PQgetvalue($ct, $i, 1);
    $amount = PQgetvalue($ct, $i, 2);
    $chqnumber = PQgetvalue($ct, $i, 3);
    $cleared = (PQgetvalue($ct, $i, 4) eq 't') ? "YES" : "NO";
    
    $oid = PQgetvalue($ct, $i, 5);

    # keep a running total
    if ($amount > 0) {
      $deposits += $amount;
    } else {
      $withdrawals += $amount;
    }
    
    $balance += $amount;
    
    printf("%s <a href=edit.pl?%s>%s</a>", $transdate, $oid, substr($description,0,25));

    $padding = 25 - length($description);
    $padding = ($padding < 0) ? 0 : $padding;
    printf("%s", " " x $padding);

    if ($amount < 0) {
      printf(" %s", " " x 8);
      printf(" %8.2f", -$amount);
    } else {
      printf(" %8.2f %s", $amount, " " x 8);
    }
    
    printf(" %8.2f %4d  %s\n", $balance, $chqnumber, $cleared);
  }
  
  printf("\n   Total Deposits:  %10.2f\n", $deposits);
  printf("Total Withdrawals:  %10.2f\n", -$withdrawals);
  
  print "</pre>";

} else {
  print "<h2><font color=red>No $tablename History!</font></h2>";
}

PQclear($ct);

PQfinish($conn);

print "

<p>
Click on the table header to sort table.
<br>Click on Description to edit TRANSACTION
 
</body>
</html>
";

