#!/usr/bin/perl


use Pg;
require('../common/config');
require('../common/wwwutil');


# read STDIN
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});

# store in array
@_ = split(/&/);

foreach (@_) {
  ($key, $value) = split(/=/);
  $var{$key} = &unescape(uc $value);
}


print "Content-type: text/html

<title>Contacts Search Results</title>

<body bgcolor=ffffff>

<h2>Contacts</h2>

<pre>
";


$query = "select *,oid from company* ";

if ($var{'name'}) {
  $query .= "where name like \'%$var{'name'}%\' ";
  $addand = 1;
  $belowlimit = (length($var{'name'}) < 3);
} else {
  $nosearch = 1;
}

if ($addand) {
  if ($var{'contact'}) {
    $query .= "and contact like \'%$var{'contact'}%\' ";
    $addand = 1;
    $belowlimit = (length($var{'contact'}) < 3);
  }
} else {
  if ($var{'contact'}) {
    $query .= "where contact like \'%$var{'contact'}%\' ";
    $addand = 1;
    $nosearch = 0;
    $belowlimit = (length($var{'contact'}) < 3);
  } else {
    $nosearch = 1;
  }
}

if ($addand) {
  if ($var{'notes'}) {
    $query .= "and notes like \'%$var{'notes'}%\' ";
  }
} else {
  if ($var{'notes'}) {
    $query .= "where notes like \'%$var{'notes'}%\' ";
    $nosearch = 0;
    $belowlimit = (length($var{'notes'}) < 3);
  } else {
    $nosearch = 1;
  }
}


if ($nosearch) {
  print "No information entered!";
  exit;
}

if ($belowlimit) {
  print "require minimum of 3 characters!";
  exit;
}


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";

$ct = PQexec($conn, $query);
$n = PQntuples($ct);

if ($n) {
  for $i (0 .. $n-1) {
      
    $name = PQgetvalue($ct, $i, 0);
    $addr1 = PQgetvalue($ct, $i, 1);
    $addr2 = PQgetvalue($ct, $i, 2);
    $addr3 = PQgetvalue($ct, $i, 3);
    $contact = PQgetvalue($ct, $i, 4);
    $phone = PQgetvalue($ct, $i, 5);
    $fax = PQgetvalue($ct, $i, 6);
    $email = PQgetvalue($ct, $i, 7);
    $website = PQgetvalue($ct, $i, 8);
    $notes = PQgetvalue($ct, $i, 9);
    $notes =~ s/\n/<br>/g;
    $oid = PQgetvalue($ct, $i, 10);

    printf("%-35s", $name);
    printf("  Tel: %s", $phone) if ($phone);
    print "\n";
    if ($addr1) {
      printf("%-35s", $addr1);
      printf("  Fax: %s", $fax) if ($fax);
      print "\n";
    } else {
      if ($fax) {
	printf("%-35s  Fax: %s\n", $addr1, $fax);
      }
    }

    if ($addr2) {
      printf("%-35s", $addr2);
      printf("  <a href=mailto:%s>%s</a>", $email, $email) if ($email);
      print "\n";
    } else {
      if ($email) {
	printf("%-35s  <a href=mailto:%s>%s</a>\n", $addr2, $email, $email);
      }
    }

    if ($addr3) {
      printf("%-35s", $addr3);
      printf("  <a href=http://%s>%s</a>", $website, $website) if ($website);
      print "\n";
    } else {
      if ($website) {
	printf("%-35s  <a href=http://%s>%s</a>\n", $addr3, $website, $website);
      }
    }

    printf("%-35s\n", $contact) if ($contact);
    printf("\n%s\n", $notes) if ($notes);

    printf("\n[ <a href=edit.pl?%s>Edit</a> ] [ <a href=delete.pl?%s>Delete</a> ]\n\n", $oid, $oid);
    printf("%s\n\n", "-" x 75);
  }
} else {
  print "<h2><font color=red>Nothing on file!</font></h2>";
}

PQclear($ct);

PQfinish($conn);

print "
</pre>

[ <a href=/cont/add.html>Add Contact</a> ] 
[ <a href=/supplier/add.pl>Add Supplier</a> ] 

<p>Note: Suppliers cannot be deleted or edited from this screen.
If you do, you'll get a \"Record does not exist\" message.
Go to the supplier section to edit suppliers!

</body>
</html>
";

