#!/usr/bin/perl


use Pg;
require('dbstruct');
require('../common/config');
require('../common/wwwutil');


# read STDIN
read(STDIN, $_, $ENV{'CONTENT_LENGTH'});


print "Content-type: text/html\n";


# connect to database
$conn = PQsetdb($pghost, $pgport, $pgoptions, $pgtty, $dbname);
(PQstatus($conn) == PGRES_CONNECTION_OK) || die "Could not connect to database $dbname";


# put items in array
@items = split(/&/);

foreach $item (@items) {
  ($key, $value) = split (/=/, $item);
  $var{$key} = $value;
}


# check if the field must be filled
if ($fldlabels[0][3]) {
  if (!($var{$fldlabels[0][0]})) {
    print "
    <body bgcolor=ffffff>

    <h2>Status</h2>
    
    <h2><font color=red>$fldlabels[0][3] must be filled in!</font></h2>";
    exit 1;
  }
}

# add all the field labels
$query = "insert into $table ($fldlabels[0][0]";
for $i (1 .. $#fldlabels) {
  $query .= ",$fldlabels[$i][0]";
  # check if the field must be filled
  if ($fldlabels[$i][3]) {
    if (!($var{$fldlabels[$i][0]})) {
      print "
      <body bgcolor=ffffff>

      <h2>Status</h2>
      
      <h2><font color=red>$fldlabels[$i][3] must be filled in!</font></h2>";
      exit 1;
    }
  }
}


$filler = ") values (";

# now add the data
for $i (0 .. $#fldlabels) {
  if ($fldlabels[$i][1] eq "C") {
    $str = uc &unescape($var{$fldlabels[$i][0]});
    if ($fldlabels[$i][2]) {
      $str =~ s/ //g;
    }
    $query .= "$filler'$str'";
  }
  
  if ($fldlabels[$i][1] eq "L") {
    $str = uc $var{$fldlabels[$i][0]};
    if (($str eq "T") || ($str eq "Y")) {
      $str = "t";
    } else {
      $str = "f";
    }
    $query .= "$filler'$str'";
  }
  
  
  if ($fldlabels[$i][1] eq "N") {
    if ($var{$fldlabels[$i][0]}) {
      $query .= "$filler$var{$fldlabels[$i][0]}";
    } else {
      $query .= "${filler}0";
    }
  }
  
  if ($fldlabels[$i][1] eq "D") {
    if ($var{$fldlabels[$i][0]}) {
      $str = &unescape($var{$fldlabels[$i][0]});
      $query .= "$filler'$str'";
    } else {
      $query .= "${filler}NULL";
    }
  }

  if ($fldlabels[$i][1] eq "S") {
    #split field into id, name pair
    @a = split(/--/, $var{$fldlabels[$i][0]});
    $str = $a[1];
    $query .= "$filler$str";
  }
  
  $filler = ",";
  
}
$query .= ");";


$ct = PQexec($conn, $query);
# check if it was added
$oid = PQoidStatus($ct);

if ($oid) {
  if ($var{'callback'}) {
    $var{'callback'} = &unescape($var{'callback'});
    print "Location: $var{'callback'}\n";
  }
  
  print "
  <body bgcolor=ffffff>
  
  <h2>Status</h2>
  
  <h2><font color=blue>Added $tablename Record</font></h2>\n";
} else {
  print "
  <body bgcolor=ffffff>
  
  <h2>Status</h2>

  ";
  &logerror("Error", "adding record to $tablename");
}

PQclear($ct);

PQfinish($conn);


print "
</body>
</html>
";


